# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::StreamAnalytics
  module Models
    #
    # Parameters supplied to the Start Streaming Job operation.
    #
    class StartStreamingJobParameters

      include MsRestAzure

      include MsRest::JSONable
      # @return [OutputStartMode] Value may be JobStartTime, CustomTime, or
      # LastOutputEventTime to indicate whether the starting point of the
      # output event stream should start whenever the job is started, start at
      # a custom user time stamp specified via the outputStartTime property, or
      # start from the last event output time. Possible values include:
      # 'JobStartTime', 'CustomTime', 'LastOutputEventTime'
      attr_accessor :output_start_mode

      # @return [DateTime] Value is either an ISO-8601 formatted time stamp
      # that indicates the starting point of the output event stream, or null
      # to indicate that the output event stream will start whenever the
      # streaming job is started. This property must have a value if
      # outputStartMode is set to CustomTime.
      attr_accessor :output_start_time


      #
      # Mapper for StartStreamingJobParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'StartStreamingJobParameters',
          type: {
            name: 'Composite',
            class_name: 'StartStreamingJobParameters',
            model_properties: {
              output_start_mode: {
                required: false,
                serialized_name: 'outputStartMode',
                type: {
                  name: 'String'
                }
              },
              output_start_time: {
                required: false,
                serialized_name: 'outputStartTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
